Download it now!
Bug 129275 - AltGr doesn't work in the Writer main document typing Old Hungarian text under Windows
Summary: AltGr doesn't work in the Writer main document typing Old Hungarian text und...
Status: RESOLVED WONTFIX
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
6.4.2.2 release
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Shortcuts-AltGR
  Show dependency treegraph
 
Reported: 2019-12-08 10:16 UTC by Kovács Viktor
Modified: 2020-04-10 18:39 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
An usuable font. (111.31 KB, application/x-font-ttf)
2019-12-08 10:16 UTC, Kovács Viktor
Details
Keyboard installer (993.50 KB, application/x-msdownload)
2019-12-08 10:21 UTC, Kovács Viktor
Details
testfile for altgr combination on Windows' Notepad (8 bytes, text/plain)
2019-12-09 16:18 UTC, Kovács Viktor
Details
Resolve alternative keyboard layouts (666 bytes, patch)
2020-02-09 16:55 UTC, Kovács Viktor
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Kovács Viktor 2019-12-08 10:16:59 UTC
Created attachment 156406 [details]
An usuable font.

Version:
6.3.3.2 (x64)
Build id.: a64200df03143b798afd1ec74a12ab50359878ed
OS: Windows 10.0; VCL: win; 
Területi beállítások: hu-HU (hu_HU); Felület nyelve: hu-HU
Calc: threaded

While typing Old Hungarian text on Writer main document, AltGr combinations of keyboard produce Tofus. Several combination of AltGr produce Tofus, and works as hotkeys. 
In textbox works.
sample output:
press AltGr+1
Required output:
𐳈‏
Old Hungarian letter small "and"
Standard:
https://unicode.org/charts/PDF/U10C80.pdf
Comment 1 Kovács Viktor 2019-12-08 10:21:25 UTC
Created attachment 156407 [details]
Keyboard installer

This keyboard can produce nonstandard characters, too. The font has these additional characters, but the standar chars are the correct positions.
Not my development.
Comment 2 Kovács Viktor 2019-12-08 10:25:16 UTC
@Stuart
Could You check me back?
Comment 3 V Stuart Foote 2019-12-08 17:10:40 UTC
Stuart->Viktor,  "Tofus" -- has what meaning?

Otherwise, I probably am unable to assist here. International keyboards with an AltGr key are not common in the U.S. market. I am reluctant to install the provided keyboard.

But I will say that for the attached 'Old Hun Emese' font, when it is installed on Windows, LibreOffice does accept its use of the Unicode reserved codepoints in the Old Hungarian block.

LibreOffices 'Special Characters' dialog maps them onto its character chart, and the full set of Rovas is available to pick to insert (or add to favorites). And on document canvas--the <Alt>+x shortcut will toggle each glyph to its Unicode hexidecimal value, e.g. 
𐳈 will become U+10CC8 -- and the reverse.

Through the 5.4 releases we had an Edit buffer for the Special Character dialog that provided a useful Input Method Editor (IME) alternative to AltGr or macOS 'Press & Hold' app (bug 42437) input, it was unfortunately stripped out but have opened bug 115477 to restore it.

So, for now for Windows users I suggest an installation of the BableStone [1] project's BableMap (current 12.0.1.7).

Again, beyond that, I am not able to help here with issues with an AltGr keycode.

=-ref-=

[1] https://www.babelstone.co.uk/Software/index.html
Comment 4 Kovács Viktor 2019-12-09 15:54:12 UTC
(In reply to V Stuart Foote from comment #3)
> Stuart->Viktor,  "Tofus" -- has what meaning?
> 
> Otherwise, I probably am unable to assist here. International keyboards with
> an AltGr key are not common in the U.S. market. I am reluctant to install
> the provided keyboard.
> 
> But I will say that for the attached 'Old Hun Emese' font, when it is
> installed on Windows, LibreOffice does accept its use of the Unicode
> reserved codepoints in the Old Hungarian block.
> 
> LibreOffices 'Special Characters' dialog maps them onto its character chart,
> and the full set of Rovas is available to pick to insert (or add to
> favorites). And on document canvas--the <Alt>+x shortcut will toggle each
> glyph to its Unicode hexidecimal value, e.g. 
> 𐳈 will become U+10CC8 -- and the reverse.
> 
> Through the 5.4 releases we had an Edit buffer for the Special Character
> dialog that provided a useful Input Method Editor (IME) alternative to AltGr
> or macOS 'Press & Hold' app (bug 42437) input, it was unfortunately stripped
> out but have opened bug 115477 to restore it.
> 
> So, for now for Windows users I suggest an installation of the BableStone
> [1] project's BableMap (current 12.0.1.7).
> 
> Again, beyond that, I am not able to help here with issues with an AltGr
> keycode.
> 
> =-ref-=
> 
> [1] https://www.babelstone.co.uk/Software/index.html

I am sorry, combining AltGr with any Old Hungarian implementations makes nullchars, not tofus. I have no informations about US marketplace.
Comment 5 Kovács Viktor 2019-12-09 16:11:51 UTC
There are an legal Old Hungarian font:

https://github.com/googlefonts/noto-fonts/tree/master/hinted/NotoSansOldHungarian

There is an Old Hungarian keyboard project based on xkeyboard-config's version 2.27. It's under GPL-3 license.
https://github.com/Kixidevel/ohu
It generated with Microsoft's keyboard layout creator version 4.0
Pressing the Keykombination AltGr with k, must be appear Old Hungarian small letter "ak", but it produces nullchar. On the notepad works this keycombination.
‏
Comment 6 Kovács Viktor 2019-12-09 16:18:55 UTC Comment hidden (obsolete)
Comment 7 Kovács Viktor 2019-12-09 20:15:46 UTC
Old Hungarian keyboard layouts need to work with the AltGr key because of that, the simple Hungarian keyboard have 102 keys for typing texts. ( letters, numbers, punctuation marks, space,tabs etc.) The Old Hungarian script have 108 symbols, and need to add for these symbols punctuation marks, and, for the currency , digital numbers. (asked the LO developers for the acceptation of hu_Hung_hu) Also need to add Righ-to-left mark. Old Hungarian fans must be use keyboards that could to buy in Hungarian marketplaces, with 102- keys.
Comment 8 Kovács Viktor 2019-12-10 07:52:27 UTC
@Stuart
MS' programs don't distinguish AltGr+any key with Alt+Ctrl+any key. Both works.
It would be the keyword for resolving this problem.
Comment 9 Kovács Viktor 2019-12-10 10:01:58 UTC
@Tamás
Could You check me back?
Comment 10 V Stuart Foote 2019-12-10 14:16:06 UTC
(In reply to Kovács Viktor from comment #8)
> @Stuart
> MS' programs don't distinguish AltGr+any key with Alt+Ctrl+any key. Both
> works.
> It would be the keyword for resolving this problem.

Well, reality is that LibreOffice currently makes no distinction between the <Left-Alt> Key and the <Right-Alt> Key that is used with <Ctrl> to simulate the keysym for the <AltGr> key when it is not present. There was work on bug 95761 to differentiate the two, but complaints forced that to be reverted.

So situation is that <Ctrl><Alt> mapping as <AltGr>  disrupts the LibreOffice <Alt>+[somekey] shortcuts and accelerator assignments, but also can impact os <AltGr> IME by locale.

Operating system, keyboard selection, and language/locale controls the <AltGr> IME mappings--not LibreOffice, we just try to keep out of the mix.

We make adjustments by ones and twos for locales that really require it, but there is no expectation of project support to map an entire range of keysyms for a custom keyboard, which is what you are asking for to support direct <AltGr> mapping for keyboard entry of the ~120 glyphs defined as 'Old Hungarian'.

It might be doable by extension, but it will never be implemented in the core of LibreOffice and this is a WONTFIX (because we can't).
Comment 11 Kovács Viktor 2019-12-13 10:59:35 UTC
(In reply to V Stuart Foote from comment #10)
> (In reply to Kovács Viktor from comment #8)
> > @Stuart
> > MS' programs don't distinguish AltGr+any key with Alt+Ctrl+any key. Both
> > works.
> > It would be the keyword for resolving this problem.
> 
> Well, reality is that LibreOffice currently makes no distinction between the
> <Left-Alt> Key and the <Right-Alt> Key that is used with <Ctrl> to simulate
> the keysym for the <AltGr> key when it is not present. There was work on bug
> 95761 to differentiate the two, but complaints forced that to be reverted.
> 
> So situation is that <Ctrl><Alt> mapping as <AltGr>  disrupts the
> LibreOffice <Alt>+[somekey] shortcuts and accelerator assignments, but also
> can impact os <AltGr> IME by locale.
> 
> Operating system, keyboard selection, and language/locale controls the
> <AltGr> IME mappings--not LibreOffice, we just try to keep out of the mix.
> 
> We make adjustments by ones and twos for locales that really require it, but
> there is no expectation of project support to map an entire range of keysyms
> for a custom keyboard, which is what you are asking for to support direct
> <AltGr> mapping for keyboard entry of the ~120 glyphs defined as 'Old
> Hungarian'.
> 
> It might be doable by extension, but it will never be implemented in the
> core of LibreOffice and this is a WONTFIX (because we can't).

It would't possible to switch on and switch of emulation AltGr in a menu? I hink about writing aids.
Comment 12 Kovács Viktor 2019-12-13 17:57:27 UTC
I think, its... Not our bug. Unfortunatelly ms klc set the altgr emulation whithout removing this setting.
Comment 13 Tamas Szabo 2019-12-18 14:30:36 UTC
I think, with a compromissum could work. My idea:
Chooseable options in the writing aids offer the following:
AltGr (alt+ctr) works as hotkeys or don't works as hotkeys, but the alternative keyboard layout could be works correctly.
Comment 14 Tamas Szabo 2019-12-18 14:33:04 UTC
(In reply to Tamas Szabo from comment #13)
> I think, with a compromissum could work. My idea:
> Chooseable options in the writing aids offer the following:
> AltGr (alt+ctr) works as hotkeys or don't works as hotkeys, but the
> alternative keyboard layout could be works correctly.

I would it made, but not immediately.
Comment 15 Tamas Szabo 2019-12-18 14:36:18 UTC
(In reply to Tamas Szabo from comment #14)
> (In reply to Tamas Szabo from comment #13)
> > I think, with a compromissum could work. My idea:
> > Chooseable options in the writing aids offer the following:
> > AltGr (alt+ctr) works as hotkeys or don't works as hotkeys, but the
> > alternative keyboard layout could be works correctly.
> 
> I would it made, but not immediately.

@Viktor
Or could you make it?
Comment 16 Kovács Viktor 2019-12-18 14:39:39 UTC
(In reply to Tamas Szabo from comment #15)
> (In reply to Tamas Szabo from comment #14)
> > (In reply to Tamas Szabo from comment #13)
> > > I think, with a compromissum could work. My idea:
> > > Chooseable options in the writing aids offer the following:
> > > AltGr (alt+ctr) works as hotkeys or don't works as hotkeys, but the
> > > alternative keyboard layout could be works correctly.
> > 
> > I would it made, but not immediately.
> 
> @Viktor
> Or could you make it?

Yes, I try.
Comment 17 Kovács Viktor 2020-01-20 18:45:26 UTC
The 1st idea, swich on/of all the hotkeys, would be resolved only for Old-Hungarian keyboard-layout(s). 
In my opinion would be better, if remap the hotkeys using the following keyboard combinations‏: 
-Controll+any key.
-Controll+Shift+ any key.
-Alt+any key.
-Alt+Shift+ any key.
I think, that must be enought;

@:Xisco Faulí
What do you think about it?
Comment 18 Kovács Viktor 2020-01-22 11:39:15 UTC
cc: Dr. Khaled Hosny.
First I believed, that combining <AltGr> keys under Windows in main Writer document blocking by Accelerators.
The typing problem is not present when use textbox inside the Writer document. Any parts of LO (calc, draw, etc..) works correctly.
May I ask you to resolve this problem?
Keyboard layout installer dowloadable from https://github.com/Kixidevel/ohu for Windows.

You could check with AltGr+A, an result letter must be appereable.
‏
Comment 19 Kovács Viktor 2020-02-09 16:55:07 UTC Comment hidden (obsolete)
Comment 20 Kovács Viktor 2020-02-09 16:59:33 UTC
May I ask somebody to testing it?
Comment 21 Kovács Viktor 2020-02-10 20:14:22 UTC
Old Hungarian keyboard layouts, as any alternative layouts, in the GetKeyboardLayout's result the highest bit set to 1. The function result casted to DWORD, you can check this bit.
The alternative layouts not work with AltGr-type accelerators correctly. I think this patch helps to use alternative layouts without accelerators.
Comment 22 Kovács Viktor 2020-02-14 20:29:49 UTC
Good bye!
Comment 23 Kovács Viktor 2020-04-10 08:11:10 UTC
cc:László Németh
I am here again.
When this bug was fired, AltGr combinations of Old Hungarian Layout didn't work only main Writer documents, in the Writer's textbox, Calc, etc. worked correctly.
Now don't work AltGr combinaions at all.
There is a must?
Comment 24 Kovács Viktor 2020-04-10 18:39:04 UTC
Cc:László Németh
I am sorry about previous comment.
I replaned my layout. The Older one have AltGr problems only in Writer main document.